#ifndef _PI_H
#define _PI_H

typedef struct PI_regs_s {
    void * ram_address;
    unsigned long pi_address;
    /* the length registers are named from the PI's
       perspective, thus read_length is the length
       to read from RAM, write_length is the length
       to write to RAM */
    unsigned long read_length;
    unsigned long write_length;
    unsigned long status;
} _PI_regs_s;

extern volatile struct PI_regs_s * const PI_regs;

#define PI_status_DMA_busy (1<<0)
#define PI_status_IO_busy (1<<1)
#define PI_status_error (1<<2)

#define PI_reset (1<<0)
#define PI_clear_interrupt (1<<1)

/* write to PI */
void PI_write(void * ram_address, unsigned long pi_address, unsigned long len);
/* read from PI */
void PI_read(void * ram_address, unsigned long pi_address, unsigned long len);
int PI_busy();

#endif
